﻿using System;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore.Migrations;

namespace ClientServer.Migrations
{
    public partial class removeSolutionVersion1 : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.CreateTable(
                name: "CustomTestWithSingleSolutionAsTestResult",
                columns: table => new
                {
                    CustomTestId = table.Column<int>(nullable: false),
                    SolutionUserId = table.Column<int>(nullable: false),
                    SolutionExerciseReleaseId = table.Column<int>(nullable: false),
                    SolutionPLangId = table.Column<int>(nullable: false),
                    HasCompiled = table.Column<bool>(nullable: true),
                    Passed = table.Column<bool>(nullable: true),
                    ProgramExitCode = table.Column<int>(nullable: true),
                    Protocol = table.Column<string>(nullable: true),
                    TestResultCode = table.Column<int>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_CustomTestWithSingleSolutionAsTestResult", x => new { x.CustomTestId, x.SolutionUserId, x.SolutionExerciseReleaseId, x.SolutionPLangId });
                    table.ForeignKey(
                        name: "FK_CustomTestWithSingleSolutionAsTestResult_CustomTest_CustomTestId",
                        column: x => x.CustomTestId,
                        principalTable: "CustomTest",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_CustomTestWithSingleSolutionAsTestResult_Solutions_SolutionUserId_SolutionExerciseReleaseId_SolutionPLangId",
                        columns: x => new { x.SolutionUserId, x.SolutionExerciseReleaseId, x.SolutionPLangId },
                        principalTable: "Solutions",
                        principalColumns: new[] { "UserId", "ExerciseReleaseId", "PLangId" },
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.CreateTable(
                name: "TestWithSingleSolutionAsTestResult",
                columns: table => new
                {
                    TestId = table.Column<int>(nullable: false),
                    SolutionUserId = table.Column<int>(nullable: false),
                    SolutionExerciseReleaseId = table.Column<int>(nullable: false),
                    SolutionPLangId = table.Column<int>(nullable: false),
                    HasCompiled = table.Column<bool>(nullable: true),
                    Passed = table.Column<bool>(nullable: true),
                    ProgramExitCode = table.Column<int>(nullable: true),
                    Protocol = table.Column<string>(nullable: true),
                    TestResultCode = table.Column<int>(nullable: true)
                },
                constraints: table =>
                {
                    table.PrimaryKey("PK_TestWithSingleSolutionAsTestResult", x => new { x.TestId, x.SolutionUserId, x.SolutionExerciseReleaseId, x.SolutionPLangId });
                    table.ForeignKey(
                        name: "FK_TestWithSingleSolutionAsTestResult_Tests_TestId",
                        column: x => x.TestId,
                        principalTable: "Tests",
                        principalColumn: "Id",
                        onDelete: ReferentialAction.Cascade);
                    table.ForeignKey(
                        name: "FK_TestWithSingleSolutionAsTestResult_Solutions_SolutionUserId_SolutionExerciseReleaseId_SolutionPLangId",
                        columns: x => new { x.SolutionUserId, x.SolutionExerciseReleaseId, x.SolutionPLangId },
                        principalTable: "Solutions",
                        principalColumns: new[] { "UserId", "ExerciseReleaseId", "PLangId" },
                        onDelete: ReferentialAction.Cascade);
                });

            migrationBuilder.AddColumn<int>(
                name: "SolutionExerciseReleaseId",
                table: "SolutionFiles",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddColumn<int>(
                name: "SolutionPLangId",
                table: "SolutionFiles",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddColumn<int>(
                name: "SolutionUserId",
                table: "SolutionFiles",
                nullable: false,
                defaultValue: 0);

            migrationBuilder.AddColumn<int>(
                name: "MainFileId",
                table: "Solutions",
                nullable: true);

            migrationBuilder.AddColumn<string>(
                name: "Note",
                table: "Solutions",
                nullable: true);

            migrationBuilder.CreateIndex(
                name: "IX_CustomTestWithSingleSolutionAsTestResult_CustomTestId",
                table: "CustomTestWithSingleSolutionAsTestResult",
                column: "CustomTestId");

            migrationBuilder.CreateIndex(
                name: "IX_CustomTestWithSingleSolutionAsTestResult_SolutionUserId_SolutionExerciseReleaseId_SolutionPLangId",
                table: "CustomTestWithSingleSolutionAsTestResult",
                columns: new[] { "SolutionUserId", "SolutionExerciseReleaseId", "SolutionPLangId" });

            migrationBuilder.CreateIndex(
                name: "IX_TestWithSingleSolutionAsTestResult_TestId",
                table: "TestWithSingleSolutionAsTestResult",
                column: "TestId");

            migrationBuilder.CreateIndex(
                name: "IX_TestWithSingleSolutionAsTestResult_SolutionUserId_SolutionExerciseReleaseId_SolutionPLangId",
                table: "TestWithSingleSolutionAsTestResult",
                columns: new[] { "SolutionUserId", "SolutionExerciseReleaseId", "SolutionPLangId" });
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropColumn(
                name: "SolutionExerciseReleaseId",
                table: "SolutionFiles");

            migrationBuilder.DropColumn(
                name: "SolutionPLangId",
                table: "SolutionFiles");

            migrationBuilder.DropColumn(
                name: "SolutionUserId",
                table: "SolutionFiles");

            migrationBuilder.DropColumn(
                name: "MainFileId",
                table: "Solutions");

            migrationBuilder.DropColumn(
                name: "Note",
                table: "Solutions");

            migrationBuilder.DropTable(
                name: "CustomTestWithSingleSolutionAsTestResult");

            migrationBuilder.DropTable(
                name: "TestWithSingleSolutionAsTestResult");
        }
    }
}
