﻿using System.ComponentModel.DataAnnotations;
using ClientServer.Db;
using ClientServer.Helpers;

namespace ClientServer.Models.Exercises
{
    /// <summary>
    /// a asset (used e.g. for the <see cref="ExerciseDescription"/> to display images, ...)
    /// </summary>
    public class Asset
    {
        public int Id { get; set; }
        /// <summary>
        /// the name of the file/asset
        /// </summary>
        [MaxLength(YapexDbContext.DefaultMaxStringLength)]
        public string DisplayName { get; set; }
        /// <summary>
        /// the asset url for assets (starts with <see cref="Constants.MarkdownAssetFileUrlPrefix"/>)
        /// this will be translatet in the browser,
        /// we use html5 file api for that
        /// 
        /// </summary>
        [MaxLength(YapexDbContext.DefaultMaxStringLength)]
        public string AssetUrl { get; set; }
        /// <summary>
        /// the content of the asset (binary)
        /// </summary>
        public byte[] Content { get; set; }
        /// <summary>
        /// the mime type (maybe we need to know what content is stored)
        /// </summary>
        [MaxLength(YapexDbContext.DefaultMaxStringLength)]
        public string MimeType { get; set; }
    }
}
